using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.Globalization;
using DGKC;
using System.IO;

namespace ObjArray
{
    /// <summary>
    /// Summary description for ObjArrayForm.
    /// </summary>
    public class ObjArrayForm : System.Windows.Forms.Form
    {
        private IContainer components;

        IModel_DG m_iModel;
        IView_DG m_iView;
        IEntity_DG m_iEntCur;

        int m_nChildCount;
        int m_nNewChild;
        int m_nCurChild;    //Index of the current object ( m_iEntCur of which already retrieved )
                            //As opposed to m_nNewChild before pressing "Set current" button

        int m_nAddedCount;

        internal SaveFileDialog SaveFileDialog;
        internal OpenFileDialog OpenFileDialog;
        private DGKC.DGKCn6 m_dgkc;
        internal Button cmdAddSO;
        private NumericUpDown nudNumObjs;
        private Button cmdClear;
        private Button cmdImportComp;
        private Button cmdImportMod;
        private Button cmdImportStandalone;
        private TextBox txtFilePath;
        internal Button ButtonOK;

        public ObjArrayForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            components = new Container();
            ComponentResourceManager resources = new ComponentResourceManager(typeof(ObjArrayForm));
            SaveFileDialog = new SaveFileDialog();
            OpenFileDialog = new OpenFileDialog();
            ButtonOK = new Button();
            m_dgkc = new DGKC.DGKCn6();
            cmdAddSO = new Button();
            nudNumObjs = new NumericUpDown();
            cmdClear = new Button();
            cmdImportComp = new Button();
            cmdImportMod = new Button();
            cmdImportStandalone = new Button();
            txtFilePath = new TextBox();
            ((ISupportInitialize)nudNumObjs).BeginInit();
            SuspendLayout();
            // 
            // ButtonOK
            // 
            ButtonOK.DialogResult = DialogResult.OK;
            ButtonOK.Location = new Point(958, 777);
            ButtonOK.Name = "ButtonOK";
            ButtonOK.Size = new Size(96, 30);
            ButtonOK.TabIndex = 15;
            ButtonOK.Text = "Close";
            ButtonOK.Click += buttonClose_Click;
            // 
            // m_dgkc
            // 
            m_dgkc.BackColor = Color.FromArgb(204, 255, 204);
            m_dgkc.Location = new Point(5, 10);
            m_dgkc.ModelPath = "";
            m_dgkc.Name = "m_dgkc";
            m_dgkc.RenderSolid = true;
            m_dgkc.ShowGlobalAxes = true;
            m_dgkc.Size = new Size(879, 797);
            m_dgkc.TabIndex = 18;
            // 
            // cmdAddSO
            // 
            cmdAddSO.DialogResult = DialogResult.OK;
            cmdAddSO.Location = new Point(1043, 229);
            cmdAddSO.Name = "cmdAddSO";
            cmdAddSO.Size = new Size(96, 30);
            cmdAddSO.TabIndex = 19;
            cmdAddSO.Text = "Add StdObjs";
            cmdAddSO.Click += cmdAddSO_Click;
            // 
            // nudNumObjs
            // 
            nudNumObjs.Location = new Point(908, 235);
            nudNumObjs.Maximum = new decimal(new int[] { -1, -1, -1, 0 });
            nudNumObjs.Minimum = new decimal(new int[] { 1, 0, 0, 0 });
            nudNumObjs.Name = "nudNumObjs";
            nudNumObjs.Size = new Size(120, 23);
            nudNumObjs.TabIndex = 20;
            nudNumObjs.Value = new decimal(new int[] { 1, 0, 0, 0 });
            // 
            // cmdClear
            // 
            cmdClear.Location = new Point(890, 187);
            cmdClear.Name = "cmdClear";
            cmdClear.Size = new Size(277, 23);
            cmdClear.TabIndex = 21;
            cmdClear.Text = "Clear";
            cmdClear.UseVisualStyleBackColor = true;
            cmdClear.Click += cmdClear_Click;
            // 
            // cmdImportComp
            // 
            cmdImportComp.Location = new Point(890, 36);
            cmdImportComp.Name = "cmdImportComp";
            cmdImportComp.Size = new Size(277, 23);
            cmdImportComp.TabIndex = 21;
            cmdImportComp.Text = "Import (Component)";
            cmdImportComp.UseVisualStyleBackColor = true;
            cmdImportComp.Click += cmdImportComp_Click;
            // 
            // cmdImportMod
            // 
            cmdImportMod.Location = new Point(890, 65);
            cmdImportMod.Name = "cmdImportMod";
            cmdImportMod.Size = new Size(277, 23);
            cmdImportMod.TabIndex = 21;
            cmdImportMod.Text = "Import (Model)";
            cmdImportMod.UseVisualStyleBackColor = true;
            cmdImportMod.Click += cmdImportMod_Click;
            // 
            // cmdImportStandalone
            // 
            cmdImportStandalone.Location = new Point(890, 94);
            cmdImportStandalone.Name = "cmdImportStandalone";
            cmdImportStandalone.Size = new Size(277, 23);
            cmdImportStandalone.TabIndex = 21;
            cmdImportStandalone.Text = "Import (Standalone Model and Entity Array)";
            cmdImportStandalone.UseVisualStyleBackColor = true;
            cmdImportStandalone.Click += cmdImportStandalone_Click;
            // 
            // txtFilePath
            // 
            txtFilePath.Location = new Point(890, 139);
            txtFilePath.Name = "txtFilePath";
            txtFilePath.Size = new Size(273, 23);
            txtFilePath.TabIndex = 22;
            txtFilePath.Text = "Model_Overall2.stl";
            // 
            // ObjArrayForm
            // 
            AutoScaleBaseSize = new Size(6, 16);
            ClientSize = new Size(1169, 841);
            Controls.Add(txtFilePath);
            Controls.Add(cmdImportStandalone);
            Controls.Add(cmdImportMod);
            Controls.Add(cmdImportComp);
            Controls.Add(cmdClear);
            Controls.Add(nudNumObjs);
            Controls.Add(cmdAddSO);
            Controls.Add(m_dgkc);
            Controls.Add(ButtonOK);
            Icon = (Icon)resources.GetObject("$this.Icon");
            Name = "ObjArrayForm";
            Text = "Object Array Sample (MemTest)";
            Load += ObjArrayForm_Load;
            ((ISupportInitialize)nudNumObjs).EndInit();
            ResumeLayout(false);
            PerformLayout();
        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new ObjArrayForm());
        }

        private void ObjArrayForm_Load(object sender, System.EventArgs e)
        {
            m_iModel = m_dgkc.GetModel();
            m_iView = m_dgkc.GetView();


            /*      m_nCurChild = 0;
                  m_nNewChild = m_nCurChild;	// No changes initially*/

            /*     ShowSolidAxes();
                 InitBackground();*/


            // Enable SaveAs context menu option (disabled by default for security)
            //   m_dgkc.ContextMenuStrip.Items["saveModelAs"].Enabled = true;
        }



        private void Fit()
        {
            IView_DG iView = m_dgkc.GetView();
            iView.Reset(true, false);
            m_dgkc.UpdateView();
        }




        private void buttonClose_Click(object sender, EventArgs e)
        {
            Close();
        }





        private void cmdAddSO_Click(object sender, EventArgs e)
        {

            IStdShape_DG m_iStdShape;

            m_iStdShape = m_iModel.As<IStdShape_DG>();

            // UpdateData(); // Get name and other settings for the new object

            IEntity_DG iEnt = null;

            int numObjs = 1;
            numObjs = (int)nudNumObjs.Value;

            for (int i = 0; i < numObjs; ++i)
            {

                iEnt = m_iStdShape.Cylinder(2, 1, m_nAddedCount + 1);

                // Translate the new object otherwise it can be inside of the previous one and it will appear as nothing has happened
                IFrame_DG iFrame = iEnt.As<IFrame_DG>();

                // By default new object is located at the global origin (0,0,0)
                iFrame.Translate(m_nAddedCount, 0, 0);

                m_nAddedCount = m_nAddedCount + 1;

                m_iModel.AddEntity(iEnt);


            }

            m_dgkc.UpdateDeep();

            Fit();

            // UpdatePage();
        }

        private void cmdImportStandalone_Click(object sender, EventArgs e)
        {
            IModel_DG iModelStandalone;
            IEntityArray_DG iArrayEnt;
            IObjectGenerator_DG gen = m_iModel.Query<IObjectGenerator_DG>();

            iModelStandalone = gen.Create<IModel_DG>();


            iModelStandalone.Load(txtFilePath.Text);

            iArrayEnt = iModelStandalone.GetEntityArray(true);

            m_iModel.Add(iArrayEnt,-1);

            m_iView.Reset(true, true);
            m_dgkc.UpdateView();

            iArrayEnt.Clear();
            iModelStandalone.RemoveAll(true);
        }

        private void cmdImportMod_Click(object sender, EventArgs e)
        {
            m_iModel.Load(txtFilePath.Text);
            m_iView.Reset(true, true);
            m_dgkc.UpdateView();
        }

        private void cmdImportComp_Click(object sender, EventArgs e)
        {
            IModel_DG iModelStandalone;
            IEntityArray_DG iArrayEnt;
            IObjectGenerator_DG gen = m_iModel.Query<IObjectGenerator_DG>();
            IDictionary_DG MyDictionary;
            IEntity_DG MyComponentEntity;

            MyDictionary = gen.Create<IDictionary_DG>();
            MyDictionary.SetBool("SeperateObjects", true);


            iModelStandalone = gen.Create<IModel_DG>();
            MyComponentEntity = gen.Create<IEntity_DG>();

            iModelStandalone.Load(txtFilePath.Text);

            iArrayEnt = iModelStandalone.GetEntityArray(false);

            MyComponentEntity.Add(iArrayEnt, -1);
            MyComponentEntity.Name = "Component";

            for (int i = 0; i < MyComponentEntity.GetChildCount(); i++)
            {
                MyComponentEntity.GetChildAt(i).Name = "Child_" + i.ToString();
            }

            m_iModel.AddEntity(MyComponentEntity);
            m_iView.Reset(true, true);
            m_dgkc.UpdateView();

            //iArrayEnt.Clear();
            //iModelStandalone.RemoveAll(true);
            //MyComponentEntity.RemoveAll(true);

            //MyComponentEntity = null;
            //iModelStandalone = null;
            //iArrayEnt = null;
        }

        private void cmdClear_Click(object sender, EventArgs e)
        {
            m_iModel.RemoveAll(true);
            m_dgkc.UpdateDeep();
            m_nAddedCount = 0;
        }
    }
}
